'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports['default'] = worker;
function worker(e) {
  var _e$data = e.data,
      id = _e$data.id,
      action = _e$data.action,
      payload = _e$data.payload;


  var sendMessage = function sendMessage(result, data) {
    self.postMessage({
      id: id,
      action: action,
      result: result,
      payload: data
    });
  };

  // eslint-disable-next-line
  var onError = function onError(ex) {
    return sendMessage(1, '' + ex);
  };
  var onSuccess = sendMessage.bind(null, 0);

  if (action === ACTIONS.COMPILE_MODULE) {
    Promise.resolve().then(function () {
      return typeof payload === 'string' ? fetch(payload).then(function (response) {
        return response.arrayBuffer();
      }) : payload;
    }).then(function (buffer) {
      return WebAssembly.compile(buffer);
    }).then(function (module) {
      return WebAssembly.instantiate(module, getImportObject !== undefined ? getImportObject() : {
        memoryBase: 0,
        tableBase: 0,
        memory: new WebAssembly.Memory({ initial: 256 }),
        table: new WebAssembly.Table({ initial: 0, element: 'anyfunc' })
      }).then(function (inst) {
        // eslint-disable-next-line
        moduleInstance = inst;
        onSuccess({
          exports: WebAssembly.Module.exports(module).filter(function (exp) {
            return exp.kind === 'function';
          }).map(function (exp) {
            return exp.name;
          })
        });
      });
    })['catch'](onError);
  } else if (action === ACTIONS.CALL_FUNCTION_EXPORT) {
    var func = payload.func,
        params = payload.params;


    Promise.resolve().then(function () {
      var ctx = moduleInstance.exports;
      // eslint-disable-next-line
      onSuccess(ctx[func].apply(ctx, params));
    })['catch'](onError);
  }
}